﻿require("bit")
require("tprint")
require("Dict\\Dic_en_US")
require("WordDict")


WordDict:Init()

--print("Contains", WordDict:Contains("This"))
--tprint(WordDict:Suggest("This"))


SPELLED_WRONG_HIGHLIGHT = "|cffffffff"
FONT_COLOR_CODE_CLOSE = "|r"


local WordCache = {}
local WordLocations = {}

function CheckLine(text)
	if text == nil then return end
	if #text == 0 then return end

	--March through the text, finding the words, and recording there start & end positions
	--Then see if the word is in the same location as last time we checked.
	--If it's a new word or changed word, spell check it.

	local ChatEditWords = {}
	local patt = "[A-Za-z0-9_'À-ÿ]+"
	local pos1
	local pos2
	pos1, pos2 = string.find(text, patt)
	pos = pos1

	local x = 1
	while pos1 ~= nil do
		pos = pos1
		local word = text:sub(pos1, pos2)
		WordLocations[x] = {["Word"] = word, ["StartPos"] = pos1, ["EndPos"] = pos2}

		if WordCache[word] == nil then
			local correct = WordDict:Contains(word)
			--Try the lower case version of the word
			if correct == false then
				correct = WordDict:Contains(string.lower(word))
			end
			WordCache[word] = {["Correct"] = correct, ["Suggestions"] = {}}
			if correct == false then
				local suggestions = {}
				suggestions = WordDict:Suggest(word)
				if #suggestions > 0 then
					WordCache[word].Suggestions = suggestions
				end
			end
		end
		x = x + 1
		pos1, pos2 = string.find(text, patt, pos2+1)
	end
end


--return a the
function HighlightMisspellings(text)
	if #text < 2 then return text end

	local newText = text
	--remove highlighting
	newText = string.gsub(newText, "|c%x%x%x%x%x%x%x%x", "")
	newText = string.gsub(newText, "|r", "")

	print("newText", newText.."#")

	CheckLine(newText)
	--Match backwords through the input text
	tprint(WordLocations)


	for x = #WordLocations, 1, -1 do
		local w = WordLocations[x]
		if WordCache[w.Word].Correct == false then
			--Insert highlighting
			newText = newText:sub(1, w.StartPos -1) .. SPELLED_WRONG_HIGHLIGHT .. newText:sub(w.StartPos, w.EndPos) .. FONT_COLOR_CODE_CLOSE .. newText:sub(w.EndPos+1)
		end
	end

	--Adjust the word StartPos and EndPos, whenever we added highlighting
	-- so the right click handler can detect the word right clicked.
	--March forward this time
	local n = 0 --NewCharsAddedCounter
	for x = 1, #WordLocations do
		local w = WordLocations[x]
		if WordCache[w.Word].Correct == false then
			w.StartPos = w.StartPos + n + #SPELLED_WRONG_HIGHLIGHT
			n = n + #SPELLED_WRONG_HIGHLIGHT
			w.EndPos = w.EndPos + n
			n = n + #FONT_COLOR_CODE_CLOSE
		end
	end

	return newText
end



s = "This is a testz findg"
--s = "This is a |cfffffffftestz|r |cfffffffffindg|r"
--HighlightMisspellings(s)

--print("Words")

tprint(WordCache)
print("Corr", HighlightMisspellings(s))
tprint(WordLocations)
